/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:26:18 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

/**
 * Represents fields that are compatible to be selected for a report of type "STANDARD".
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ReportCompatibleFields extends com.google.api.client.json.GenericJson {

  /**
   * Dimensions which are compatible to be selected in the "dimensionFilters" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Dimension> dimensionFilters;

  /**
   * Dimensions which are compatible to be selected in the "dimensions" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Dimension> dimensions;

  /**
   * The kind of resource this is, in this case dfareporting#reportCompatibleFields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Metrics which are compatible to be selected in the "metricNames" section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Metric> metrics;

  /**
   * Metrics which are compatible to be selected as activity metrics to pivot on in the "activities"
   * section of the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Metric> pivotedActivityMetrics;

  /**
   * Dimensions which are compatible to be selected in the "dimensionFilters" section of the report.
   * @return value or {@code null} for none
   */
  public java.util.List<Dimension> getDimensionFilters() {
    return dimensionFilters;
  }

  /**
   * Dimensions which are compatible to be selected in the "dimensionFilters" section of the report.
   * @param dimensionFilters dimensionFilters or {@code null} for none
   */
  public ReportCompatibleFields setDimensionFilters(java.util.List<Dimension> dimensionFilters) {
    this.dimensionFilters = dimensionFilters;
    return this;
  }

  /**
   * Dimensions which are compatible to be selected in the "dimensions" section of the report.
   * @return value or {@code null} for none
   */
  public java.util.List<Dimension> getDimensions() {
    return dimensions;
  }

  /**
   * Dimensions which are compatible to be selected in the "dimensions" section of the report.
   * @param dimensions dimensions or {@code null} for none
   */
  public ReportCompatibleFields setDimensions(java.util.List<Dimension> dimensions) {
    this.dimensions = dimensions;
    return this;
  }

  /**
   * The kind of resource this is, in this case dfareporting#reportCompatibleFields.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case dfareporting#reportCompatibleFields.
   * @param kind kind or {@code null} for none
   */
  public ReportCompatibleFields setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Metrics which are compatible to be selected in the "metricNames" section of the report.
   * @return value or {@code null} for none
   */
  public java.util.List<Metric> getMetrics() {
    return metrics;
  }

  /**
   * Metrics which are compatible to be selected in the "metricNames" section of the report.
   * @param metrics metrics or {@code null} for none
   */
  public ReportCompatibleFields setMetrics(java.util.List<Metric> metrics) {
    this.metrics = metrics;
    return this;
  }

  /**
   * Metrics which are compatible to be selected as activity metrics to pivot on in the "activities"
   * section of the report.
   * @return value or {@code null} for none
   */
  public java.util.List<Metric> getPivotedActivityMetrics() {
    return pivotedActivityMetrics;
  }

  /**
   * Metrics which are compatible to be selected as activity metrics to pivot on in the "activities"
   * section of the report.
   * @param pivotedActivityMetrics pivotedActivityMetrics or {@code null} for none
   */
  public ReportCompatibleFields setPivotedActivityMetrics(java.util.List<Metric> pivotedActivityMetrics) {
    this.pivotedActivityMetrics = pivotedActivityMetrics;
    return this;
  }

  @Override
  public ReportCompatibleFields set(String fieldName, Object value) {
    return (ReportCompatibleFields) super.set(fieldName, value);
  }

  @Override
  public ReportCompatibleFields clone() {
    return (ReportCompatibleFields) super.clone();
  }

}
